###Meta-analysis with metafor and forest plot with forestplot###
library("metafor")
#library("tcltk2")
library("forestplot")
############

############
makeforest=function(res){
if(res$measure=="RR"||res$measure=="OR"||exdat$label[6]=="HR")
{
rr=as.vector(exp(res$b))
rrup=exp(res$ci.ub)
rrlw=exp(res$ci.lb)
irr=as.vector(exp(res$yi))
irrup=as.vector(exp(res$yi+1.96*sqrt(res$vi)))
irrlw=as.vector(exp(res$yi-1.96*sqrt(res$vi)))
zerov=1

##setting clips
ue=res$yi+1.96*sqrt(res$vi)
clipu=max(ue)
niban=max(ue[ue<clipu])
isa=clipu-niban
if(isa>0.3)
{
clipu=niban+0.3
}
clipu=exp(clipu)
clipu=round(clipu,digits=2)
if(clipu<1){clipu=1}

sita=res$yi-1.96*sqrt(res$vi)
clipl=min(sita)
sniban=min(sita[sita>clipl])
ssa=sniban-clipl
if(ssa>0.3)
{
clipl=sniban-0.3
}
clipl=exp(clipl)
clipl=signif(clipl,digits=2)
##
}

if(res$measure=="RD"||res$measure=="MD")
{
rr=as.vector(res$b)
rrup=res$ci.ub
rrlw=res$ci.lb
irr=as.vector(res$yi)
irrup=as.vector(res$yi+1.96*sqrt(res$vi))
irrlw=as.vector(res$yi-1.96*sqrt(res$vi))
zerov=0

##setting clips
ue=res$yi+1.96*sqrt(res$vi)
clipu=max(ue)
niban=max(ue[ue<clipu])
isa=clipu-niban
if(isa>0.3)
{
clipu=niban+0.3
}
clipu=round(clipu,digits=2)
if(clipu<0){clipu=0}

synl=res$yi
cliplsyn=min(synl)

sita=res$yi-1.96*sqrt(res$vi)
clipl=min(sita)
sniban=min(sita[sita>clipl])
ssa=sniban-clipl
if(ssa>0.3 && cliplsyn<clipl)
{
clipl=sniban-0.3
clipl=signif(clipl,digits=2)
}
##
}

if(res$measure=="PR")
{
rr=as.vector(res$b)
rrup=res$ci.ub
rrlw=res$ci.lb
irr=as.vector(res$yi)
irrup=as.vector(res$yi+1.96*sqrt(res$vi))
irrlw=as.vector(res$yi-1.96*sqrt(res$vi))
zerov=0

##setting clips
clipu=max(irrup)
niban=max(irrup[irrup<clipu])
isa=clipu-niban
if(isa>0.3)
{
clipu=niban+0.3
}
clipu=round(clipu,digits=2)
if(clipu<0){clipu=0}
clipl=min(irrlw)
sniban=min(irrlw[irrlw>clipl])
ssa=sniban-clipl
if(ssa>0.3)
{
clipl=sniban-0.3
clipl=signif(clipl,digits=2)
}
##
}

k=res$k
w=1/(as.vector(res$vi)+res$tau2)
wp=w/sum(w)
wpc=100*wp
wpc=format(round(wpc,digits=1),nsmall=1)

#setting fs for cex
fs=1
if(k>20){fs=round((1-0.02*(k-20)),digits=1)}

m=c(NA,NA,irr,rr,NA)
lw=c(NA,NA,irrlw,rrlw,NA)
up=c(NA,NA,irrup,rrup,NA)

hete1=paste("Q=",format(round(res$QE,digits=1),nsmall=1),sep="")
hete2=paste("p=",format(round(res$QEp,digits=4),nsmall=4),sep="")

if(res$QEp<0.0001){hete2="p<0.0001"}
hete3=paste("I2=",format(round(res$I2,digits=1),nsmall=1),"%",sep="")
hete4=paste("tau2=",format(round(res$tau2,digits=4),nsmall=4),sep="")

hete5=paste("Z=",format(round(res$zval,digits=2),nsmall=2),sep="")
hete6=paste("p=",format(round(res$pval,digits=4),nsmall=4),sep="")
if(res$pval<0.0001){hete6="p<0.0001"}

au=exdat$author[exdat$author[]!=""]
sl=c(NA,toString(exdat$label[1]),as.vector(au),"Summary",NA)

ncl=c(toString(exdat$label[2]),"Number",nck,NA,hete1)
rcl=c(NA,outcc,rck,NA,hete2)

ntl=c(toString(exdat$label[3]),"Number",ntk,NA,hete3)
rtl=c(NA,outct,rtk,NA,hete4)

spac=c("    ",NA,rep(NA,k),NA,NA)
ml=c(NA,toString(exdat$label[5]),format(round(irr,digits=3),nsmall=3),format(round(rr,digits=3),nsmall=3),hete5)
ll=c(NA,"95% CI lower",format(round(irrlw,digits=3),nsmall=3),format(round(rrlw,digits=3),nsmall=3),hete6)
ul=c(NA,"95% CI upper",format(round(irrup,digits=3),nsmall=3),format(round(rrup,digits=3),nsmall=3),NA)
wpcl=c(NA,"Weight(%)",wpc,100,NA)

sum=c(TRUE,TRUE,rep(FALSE,k),TRUE,FALSE)

if(res$measure=="RD"||res$measure=="MD"){
labeltext=cbind(sl,ntl,rtl,ncl,rcl,spac,ml,ll,ul,wpcl)
hlines=list("3"=gpar(lwd=1,columns=1:11,col="grey"))
dev.new()
forestplot(labeltext,mean=m,lower=lw,upper=up,is.summary=sum,graph.pos=7,clip=c(clipl,clipu),
zero=zerov,hrzl_lines=hlines,xlab=toString(exdat$label[5]),txt_gp=fpTxtGp(ticks=gpar(cex=fs),
xlab=gpar(cex=fs),cex=fs),xticks.digits=2,vertices=TRUE,graphwidth=unit(50,"mm"),colgap=unit(3,"mm"),
lineheight="auto",xlog=FALSE,new_page=FALSE)
}

if(res$measure=="RR"||res$measure=="OR"||exdat$label[6]=="HR"){
labeltext=cbind(sl,ntl,rtl,ncl,rcl,spac,ml,ll,ul,wpcl)
hlines=list("3"=gpar(lwd=1,columns=1:11,col="grey"))
dev.new()
forestplot(labeltext,mean=m,lower=lw,upper=up,is.summary=sum,graph.pos=7,clip=c(clipl,clipu),
zero=zerov,hrzl_lines=hlines,xlab=toString(exdat$label[5]),txt_gp=fpTxtGp(ticks=gpar(cex=fs),
xlab=gpar(cex=fs),cex=fs),xticks.digits=2,vertices=TRUE,graphwidth=unit(50,"mm"),colgap=unit(3,"mm"),
lineheight="auto",xlog=TRUE,new_page=FALSE)

}


##For proportion (PR)
if(res$measure=="PR")
{
ncl=c(outcc,toString(exdat$label[2]),nck,NA,hete1)
rcl=c(NA,toString(exdat$label[3]),rck,NA,hete2)
ml=c(NA,toString(exdat$label[5]),format(round(irr,digits=3),nsmall=3),format(round(rr,digits=3),nsmall=3),hete3)
ll=c(NA,"95% CI lower",format(round(irrlw,digits=3),nsmall=3),format(round(rrlw,digits=3),nsmall=3),hete4)
labeltext=cbind(sl,ncl,rcl,spac,ml,ll,ul,wpcl)
hlines=list("3"=gpar(lwd=1,columns=1:9,col="grey"))
dev.new(width=10,height=10)
forestplot(labeltext,mean=m,lower=lw,upper=up,is.summary=sum,graph.pos=5,clip=c(clipl,clipu),
zero=zerov,hrzl_lines=hlines,xlab=toString(exdat$label[5]),txt_gp=fpTxtGp(ticks=gpar(cex=fs),
xlab=gpar(cex=fs),cex=fs),xticks.digits=2,vertices=TRUE,graphwidth=unit(60,"mm"),colgap=unit(3,"mm"),
lineheight="auto",xlog=FALSE,new_page=FALSE)
}

###Funnel plot
egger=regtest(res, model="lm", predictor="sei", ret.fit=FALSE)
begg=ranktest(res)
fsfn=1
em=toString(exdat$label[5])
outyes=toString(exdat$label[4])
dev.new(width=6,height=6)
funnel(res,xlab=paste(em,": ",outyes,sep=""))

funmax=par("usr")[3]-par("usr")[4]
gyou=funmax/12
fxmax=par("usr")[2]-(par("usr")[2]-par("usr")[1])/40
text(fxmax,gyou*0.5,"Begg's test",pos=2,cex=fsfn)
kentau=toString(round(begg$tau,digits=3))
text(fxmax,gyou*1.2,paste("Kendall's tau=",kentau,sep=""),pos=2,cex=fsfn)
kenp=toString(round(begg$pval,digits=5))
text(fxmax,gyou*1.9,paste("p=",kenp,sep=""),pos=2,cex=fsfn)

text(fxmax,gyou*3.5,"Egger's test",pos=2,cex=fsfn)
tstat=toString(round(egger$zval,digits=3))
text(fxmax,gyou*4.2,paste("t statistic=",tstat,sep=""),pos=2,cex=fsfn)
tstap=toString(round(egger$pval,digits=5))
text(fxmax,gyou*5.1,paste("p=",tstap,sep=""),pos=2,cex=fsfn)

#Print the results to the console.
print(summary(res))
print("Egger's test:")
print(egger)
print("Begg's test")
print(begg)
}
###The end of fucntion makeforest###################################
##########Bias-adjusted meta-analysis for Risk Ratio (RR):makeforestb( )#########
makeforestb=function(){
rr=as.vector(exp(resrr$b))
rrup=exp(resrr$ci.ub)
rrlw=exp(resrr$ci.lb)
irr=as.vector(exp(resrr$yi))
irrup=as.vector(exp(resrr$yi+1.96*sqrt(resrr$vi)))
irrlw=as.vector(exp(resrr$yi-1.96*sqrt(resrr$vi)))

rrb=as.vector(exp(resrrb$b))
rrupb=exp(resrrb$ci.ub)
rrlwb=exp(resrrb$ci.lb)
irrb=as.vector(exp(resrrb$yi))
irrupb=as.vector(exp(resrrb$yi+1.96*sqrt(resrrb$vi)))
irrlwb=as.vector(exp(resrrb$yi-1.96*sqrt(resrrb$vi)))

zerov=1

##setting clips
ue=resrr$yi+1.96*sqrt(resrr$vi)
clipu=max(ue)
niban=max(ue[ue<clipu])
isa=clipu-niban
if(isa>0.3)
{
clipu=niban+0.3
}
clipu=exp(clipu)
clipu=round(clipu,digits=2)

ueb=resrrb$yi+1.96*sqrt(resrrb$vi)
clipub=max(ueb)
nibanb=max(ueb[ueb<clipub])
isab=clipub-nibanb
if(isab>0.3)
{
clipub=nibanb+0.3
}
clipub=exp(clipub)
clipub=round(clipub,digits=2)

if(clipub>clipu)
{
clipu=clipub
}

if(clipu<1){clipu=1}

sita=resrr$yi-1.96*sqrt(resrr$vi)
clipl=min(sita)
sniban=min(sita[sita>clipl])
ssa=sniban-clipl
if(ssa>0.3)
{
clipl=sniban-0.3
}

sitab=resrrb$yi-1.96*sqrt(resrrb$vi)
cliplb=min(sitab)
snibanb=min(sitab[sitab>cliplb])
ssa=snibanb-cliplb
if(ssa>0.3)
{
cliplb=snibanb-0.3
}

if(cliplb<clipl){
clipl=cliplb
}

clipl=exp(clipl)
clipl=signif(clipl,digits=2)
##

k=resrr$k
w=1/(as.vector(resrr$vi)+resrr$tau2)
wp=w/sum(w)
wpc=100*wp
wpc=format(round(wpc,digits=1),nsmall=1)

wb=1/(as.vector(resrrb$vi)+resrrb$tau2)
wpb=wb/sum(wb)
wpcb=100*wpb
wpcb=format(round(wpcb,digits=1),nsmall=1)

#setting fs for cex
fs=1
kn=k*2
if(kn>20){fs=round((1-0.02*(kn-20)),digits=1)}

m=c(NA,NA,irr,rr,NA,NA)
lw=c(NA,NA,irrlw,rrlw,NA,NA)
up=c(NA,NA,irrup,rrup,NA,NA)

mb=c(NA,NA,irrb,rrb,NA,NA)
lwb=c(NA,NA,irrlwb,rrlwb,NA,NA)
upb=c(NA,NA,irrupb,rrupb,NA,NA)

hete1=paste("Q=",format(round(resrr$QE,digits=1),nsmall=1),sep="")
hete2=paste("p=",format(round(resrr$QEp,digits=4),nsmall=4),sep="")
if(resrr$QEp<0.0001){hete2="p<0.0001"}
hete3=paste("I2=",format(round(resrr$I2,digits=1),nsmall=1),"%",sep="")
hete4=paste("tau2=",format(round(resrr$tau2,digits=4),nsmall=4),sep="")
hete5=paste("Z=",format(round(resrr$zval,digits=2),nsmall=2),sep="")
hete6=paste("p=",format(round(resrr$pval,digits=4),nsmall=4),sep="")
if(resrr$pval<0.0001){hete6="p<0.0001"}

hete1b=paste("Q=",format(round(resrrb$QE,digits=1),nsmall=1),sep="")
hete2b=paste("p=",format(round(resrrb$QEp,digits=4),nsmall=4),")",sep="")
if(resrrb$QEp<0.0001){hete2b="p<0.0001)"}
hete3b=paste("(I2=",format(round(resrrb$I2,digits=1),nsmall=1),"%",sep="")
hete4b=paste("tau2=",format(round(resrrb$tau2,digits=4),nsmall=4),")",sep="")
hete5b=paste("(Z=",format(round(resrrb$zval,digits=2),nsmall=2),sep="")
hete6b=paste("p=",format(round(resrrb$pval,digits=4),nsmall=4),sep="")
if(resrrb$pval<0.0001){hete6b="p<0.0001"}

au=exdat$author[exdat$author[]!=""]
sl=c(NA,toString(exdat$label[1]),as.vector(au),"Summary",NA,NA)

ncl=c(toString(exdat$label[2]),"Number",nck,hete1,hete1b,hete3b)
rcl=c(NA,outcc,rck,hete2,hete2b,hete4b)

ntl=c(toString(exdat$label[3]),"Number",ntk,hete5,hete5b,hete3)
rtl=c(NA,outct,rtk,hete6,hete6b,hete4)

spac=c("    ",NA,rep(NA,k),NA,NA,NA)
ml=c(NA,toString(exdat$label[5]),format(round(irr,digits=3),nsmall=3),format(round(rr,digits=3),nsmall=3),format(round(rrb,digits=3),nsmall=3),NA)
ll=c(NA,"95% CI lower",format(round(irrlw,digits=3),nsmall=3),format(round(rrlw,digits=3),nsmall=3),format(round(rrlwb,digits=3),nsmall=3),NA)
ul=c(NA,"95% CI upper",format(round(irrup,digits=3),nsmall=3),format(round(rrup,digits=3),nsmall=3),format(round(rrupb,digits=3),nsmall=3),NA)
wpcl=c(NA,"Weight(%)",wpc,100,NA,NA)
wpcbl=c(NA,NA,wpcb,NA,NA,NA)

sum=c(TRUE,TRUE,rep(FALSE,k),TRUE,FALSE,FALSE)

if(resrr$measure=="RD"||resrr$measure=="MD"){
labeltext=cbind(sl,ntl,rtl,ncl,rcl,spac,ml,ll,ul,wpcl)
hlines=list("3"=gpar(lwd=1,columns=1:11,col="grey"))
dev.new()
forestplot(labeltext,mean=mean,lower=lw,upper=up,is.summary=sum,graph.pos=7,clip=c(clipl,clipu),
zero=zerov,hrzl_lines=hlines,xlab=toString(exdat$label[5]),txt_gp=fpTxtGp(ticks=gpar(cex=fs),
xlab=gpar(cex=fs),cex=fs),xticks.digits=2,vertices=TRUE,graphwidth=unit(50,"mm"),colgap=unit(3,"mm"),
lineheight="auto",xlog=FALSE,new_page=FALSE)
}

labeltext=cbind(sl,ntl,rtl,ncl,rcl,spac,ml,ll,ul,wpcl,wpcbl)

#label=list(gpar(col="black"),gpar(col="black"),gpar(col="black"),gpar(col="black"),gpar(col="black"),
#gpar(col="black"),gpar(col="black"),gpar(col="black"),gpar(col="black"),gpar(col="black"),gpar(col="grey"))),

hlines=list("3"=gpar(lwd=1,columns=1:12,col="grey"))

dev.new()
forestplot(labeltext,mean=cbind(mb,m),lower=cbind(lwb,lw),upper=cbind(upb,up),is.summary=sum,graph.pos=7,clip=c(clipl,clipu),
zero=zerov,hrzl_lines=hlines,xlab=toString(exdat$label[5]),txt_gp=fpTxtGp(ticks=gpar(cex=fs),
xlab=gpar(cex=fs),cex=fs),
xticks.digits=2,vertices=TRUE,
graphwidth=unit(50,"mm"),colgap=unit(3,"mm"),
col=fpColors(box=c("grey","black"),summary=c("grey","black")),line.margin=0.5,boxsize=0.25,lineheight="auto",xlog=TRUE,new_page=FALSE)

}
###The end of fucntion makeforestb##############
##########Make forest plot of bias: bmakefores( ) function######
bmakeforest=function(res){
res=resrr
if(is.element("biasuci",colnames(exdat))||is.element("biasusd",colnames(exdat)))
{
if(is.element("biasuci",colnames(exdat)))
{
biasv=((log(na.omit(exdat$biasuci))-biasln)/1.96)^2	#For RR and 95%CI upper limit.
}
if(is.element("biasusd",colnames(exdat)))
{
biasv=(log(na.omit(exdat$biasusd))-biasln)^2			#For RR and +1SD.
}
}
irr=as.vector(na.omit(exdat$bias))
irrup=exp(log(irr)+1.96*sqrt(biasv))
irrlw=exp(log(irr)-1.96*sqrt(biasv))

zerov=1

##setting clips
ue=log(irr)+1.96*sqrt(biasv)
clipu=max(ue)
niban=max(ue[ue<clipu])
isa=clipu-niban
if(isa>0.3)
{
clipu=niban+0.3
}
clipu=exp(clipu)
clipu=round(clipu,digits=2)
if(clipu<1){clipu=1}

sita=log(irr)-1.96*sqrt(biasv)
clipl=min(sita)
sniban=min(sita[sita>clipl])
ssa=sniban-clipl
if(ssa>0.3)
{
clipl=sniban-0.3
}
clipl=exp(clipl)
clipl=signif(clipl,digits=2)
##

k=length(irr)

w=1/(as.vector(res$vi)+res$tau2)
wp=w/sum(w)
wpc=100*wp
wpc=format(round(wpc,digits=1),nsmall=1)

#setting fs for cex
fs=1
if(k>20){fs=round((1-0.02*(k-20)),digits=1)}

m=c(NA,NA,irr,NA)
lw=c(NA,NA,irrlw,NA)
up=c(NA,NA,irrup,NA)

au=exdat$author[exdat$author[]!=""]
sl=c(NA,toString(exdat$label[1]),as.vector(au),NA)

ncl=c(toString(exdat$label[2]),"Number",nck,NA)
rcl=c(NA,outcc,rck,NA)

ntl=c(toString(exdat$label[3]),"Number",ntk,NA)
rtl=c(NA,outct,rtk,NA)

spac=c("    ",NA,rep(NA,k),NA)
ml=c(NA,toString(exdat$label[5]),format(round(irr,digits=3),nsmall=3),NA)
ll=c(NA,"95% CI lower",format(round(irrlw,digits=3),nsmall=3),NA)
ul=c(NA,"95% CI upper",format(round(irrup,digits=3),nsmall=3),NA)
wpcl=c(NA,"Weight(%)",wpc,100)

sum=c(TRUE,TRUE,rep(FALSE,k),TRUE)

labeltext=cbind(sl,ntl,rtl,ncl,rcl,spac,ml,ll,ul,wpcl)
hlines=list("3"=gpar(lwd=1,columns=1:11,col="grey"))
dev.new()
forestplot(labeltext,mean=m,lower=lw,upper=up,is.summary=sum,graph.pos=7,clip=c(clipl,clipu),
zero=zerov,hrzl_lines=hlines,xlab=toString(exdat$label[5]),txt_gp=fpTxtGp(ticks=gpar(cex=fs),
xlab=gpar(cex=fs),cex=fs),xticks.digits=2,vertices=TRUE,graphwidth=unit(50,"mm"),colgap=unit(3,"mm"),
lineheight="auto",xlog=TRUE,new_page=FALSE)
}
###The end of bmakefores()##############
###----------------------------------------------------------
#exdat=read.delim("clipboard",sep="\t",header=TRUE)

#Prepare data via clipboard from Excel for making forestplot.
for(i in 1:ncol(exdat))
{
if(colnames(exdat)[i]=="cpos"){colnames(exdat)[i]="rc"}
if(colnames(exdat)[i]=="tpos"){colnames(exdat)[i]="rt"}
}

#Do meta-analysis with metafor.
#Risk Ratio (RR)
if(exdat$label[6]=="RR")
{
rtk=as.vector(na.omit(exdat$rt))
ntk=as.vector(na.omit(exdat$nt))
rck=as.vector(na.omit(exdat$rc))
nck=as.vector(na.omit(exdat$nc))
resrr=rma(ai=rtk, bi=ntk-rtk,ci=rck,di=nck-rck,measure="RR",method="REML")
outcc=toString(exdat$label[4])
outct=outcc
makeforest(resrr)

#Risk Ratio: Bias-adjusted meta-analysis: effect size and variacne are adjusted.
if(is.element("biasuci",colnames(exdat))||is.element("biasusd",colnames(exdat)))
{
biasln=log(as.vector(na.omit(exdat$bias)))
if(is.element("biasuci",colnames(exdat)))
{
biasv=((log(na.omit(exdat$biasuci))-biasln)/1.96)^2	#For RR and 95%CI upper limit.
}
if(is.element("biasusd",colnames(exdat)))
{
biasv=(log(na.omit(exdat$biasusd))-biasln)^2			#For RR and +1SD.
}

est=escalc(measure="RR",add=0.5,to="only0",drop00=TRUE,ai=rtk, bi=ntk-rtk,ci=rck,di=nck-rck,method="REML")
yib=est$yi-biasln	#RR is adjusted with log bias.
vib=est$vi+biasv	#Variance is adjusted with bias variance on log scale.
resrrb=rma(yi=yib,vi=vib,measure="RR",method="REML")
makeforest(resrrb)

#Overlayed plot.
makeforestb()

#Forest plot of bias
bmakeforest(resrr)
}

}

#Risk Difference (RD)
if(exdat$label[6]=="RD")
{
rtk=as.vector(na.omit(exdat$rt))
ntk=as.vector(na.omit(exdat$nt))
rck=as.vector(na.omit(exdat$rc))
nck=as.vector(na.omit(exdat$nc))
resrd=rma(ai=rtk, bi=ntk-rtk,ci=rck,di=nck-rck,measure="RD",method="REML")
outcc=toString(exdat$label[4])
outct=outcc
makeforest(resrd)
}
#Odds Ratio (OR)
if(exdat$label[6]=="OR")
{
rtk=as.vector(na.omit(exdat$rt))
ntk=as.vector(na.omit(exdat$nt))
rck=as.vector(na.omit(exdat$rc))
nck=as.vector(na.omit(exdat$nc))
resor=rma(ai=rtk, bi=ntk-rtk,ci=rck,di=nck-rck,measure="OR",method="REML")
outcc=toString(exdat$label[4])
outct=outcc
makeforest(resor)
}

#Meand Difference (continuous variable: mean SD)
if(exdat$label[6]=="MD")
{
n2i=as.vector(na.omit(exdat$n2i))
m2i=as.vector(na.omit(exdat$m2i))
sd2i=as.vector(na.omit(exdat$sd2i))
n1i=as.vector(na.omit(exdat$n1i))
m1i=as.vector(na.omit(exdat$m1i))
sd1i=as.vector(na.omit(exdat$sd1i))
ns=length(n2i)

rck=rep(NA,ns)
rtk=rck
for(i in 1:ns)
{
rtk[i]=paste(m1i[i]," (",sd1i[i],")",sep="")
rck[i]=paste(m2i[i]," (",sd2i[i],")",sep="")
}

nck=n2i
ntk=n1i
resmd=rma(n2i=n2i,m2i=m2i,sd2i=sd2i,n1i=n1i,m1i=m1i,sd1i=sd1i,measure="MD",method="REML")
outcc="Mean (SD)"
outct="Mean (SD)"
makeforest(resmd)
}

#Hazard Ratio (log HR and SE) or general mean and SE (SD)
if(exdat$label[6]=="HR"||exdat$label[6]=="GEN")
{
yi=as.vector(na.omit(exdat$yi))
sei=as.vector(na.omit(exdat$sei))
nc=as.vector(na.omit(exdat$nc))
nt=as.vector(na.omit(exdat$nt))

ns=length(yi)
rck=rep(NA,ns)
rtk=rck
nck=nc
ntk=nt
reshr=rma(yi=yi,sei=sei,method="REML")
outcc=NA
outct=NA
makeforest(reshr)
}

#Proportion or rate (PR)
if(exdat$label[6]=="PR")
{
ni=as.vector(na.omit(exdat$ni))
xi=as.vector(na.omit(exdat$xi))
ns=length(ni)
nck=ni
rck=xi

ntk=rep(NA,ns)
rtk=ntk

respr=rma(xi=xi,ni=ni,measure="PR",method="REML",data=exdat)
outcc=NA
outct=NA
makeforest(respr)
}
########################
#####################End of the script##############################